package net.kierenb.mapcast.api;

import java.io.IOException;
import java.io.PrintStream;
import java.util.Map;

import net.kierenb.mapcast.ReplicatedMapServer;
import net.kierenb.mapcast.util.HttpResource;

import org.simpleframework.http.Request;
import org.simpleframework.http.Response;

/**
 * Copyright 2012 Kieren Beckett
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 * 
 * @author mail@kierenb.net
 */
public class LagResource implements HttpResource {

    public static final String URL = "/lag/";

    private ReplicatedMapServer server;

    public LagResource(ReplicatedMapServer server) {
        this.server = server;
    }

    @Override
    public String getUrl() {
        return URL;
    }

    @Override
    public void handle(Request req, Response resp) throws IOException {
        if (!"GET".equals(req.getMethod())) {
            resp.setCode(405);
            return;
        }

        if (!URL.equals(req.getPath().getPath())) {
            resp.setCode(404);
            return;
        }
        
        resp.set("content-type", "text/csv");
        PrintStream out = resp.getPrintStream();
        for (Map.Entry<String, Long> entry : server.getLag().entrySet()) {
            out.println(entry.getKey()+","+entry.getValue());
        }
    }

}
