package net.kierenb.mapcast.serializer;

import net.kierenb.mapcast.replication.EntryDao;

/**
 * Copyright 2012 Kieren Beckett
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 * 
 * @author mail@kierenb.net
 */
public class StringKeySerializer implements KeySerializer<String> {

    @Override
    public String toObject(String key) {
        return key;
    }

    @Override
    public String fromObject(Object obj) {
        if (obj == null) {
            throw new IllegalArgumentException("Key cannot be null");
        }

        if (!(obj instanceof String)) {
            return null;
        }

        if (((String)obj).length() > EntryDao.MAX_KEY_LENGTH) {
            throw new IllegalArgumentException("Key length too long");
        }

        return (String)obj;
    }

}
