package net.kierenb.mapcast.sql;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * Copyright 2012 Kieren Beckett
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 * 
 * @author mail@kierenb.net
 */
public interface ResultTransformer<R> {

    public static ResultTransformer<Boolean> HAS_ROWS = new ResultTransformer<Boolean>() {
        @Override
        public Boolean transform(ResultSet rs) throws SQLException {
            return rs.next();
        }
    };

    public R transform(ResultSet rs) throws SQLException;

}
