package net.kierenb.mapcast.util;

import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * Copyright 2012 Kieren Beckett
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 * 
 * @author mail@kierenb.net
 */
public class Collections {

    public static <V> List<V> newList(V... values) {
        return Arrays.asList(values);
    }

    public static <V> Set<V> newSet(V... values) {
        Set<V> set = new HashSet<V>();
        for (V value : values) {
            set.add(value);
        }
        return set;
    }

    public static <K, V> Map<K, V> newMap(K key1, V value1, K key2, V value2) {
        Map<K, V> map = newMap(key1, value1);
        map.put(key2, value2);
        return map;
    }

    public static <K, V> Map<K, V> newMap(K key1, V value1) {
        Map<K, V> map = newMap();
        map.put(key1, value1);
        return map;
    }

    public static <K, V> Map<K, V> newMap() {
        return new HashMap<K, V>();
    }

}
